(* ACAP contexts.

 The connection holding the context has the pointer to the context.
*)

signature CONTEXT =
sig
  structure Dataset : DATASET
  structure Throttle : THROTTLE
  structure AcapTime : ACAPTIME

  (* messages to contexts *)
  datatype inMsg = 
    ADD of (string * Dataset.export)
  | DONEADD
  | ADDEVENT of (string * Dataset.updatemsg CML.event)
  | DELETECONTEXT
  | UPDATECONTEXT
  | SEARCH of ((int option * Dataset.export) -> bool) * 
               (string * Dataset.export) Throttle.throttle *
	       (AcapTime.acaptime * (AcapTime.acaptime -> unit))

  datatype outMsg = 
    CNEW of Dataset.export * int option
  | CCHANGE of Dataset.export * (int * int) option
  | CDELETE of Dataset.export * int option
  | CTIME of AcapTime.acaptime
  | CDIE

  type search = (int option * Dataset.export) -> bool
       (* int option is the place in the context *)

  type sort = ((string * Dataset.export) * 
	       (string * Dataset.export)) -> order

  (* search string
     messenger option NOTIFY
     sort option SORT
     bool ENUMERATE *)
  val create : Dataset.Acl.Auth.ident -> (Dataset.export -> bool) 
    -> outMsg CML.chan option 
    -> sort option -> bool -> (string * Dataset.export) Throttle.throttle 
    -> inMsg CML.chan

end
