structure Queue :> QUEUE =
struct
  type 'a queue = 'a list * 'a list

  exception Empty

  val empty = (nil, nil)

  fun add (l1, l2) a = (a::l1, l2)

  fun remove (nil, nil) = raise Empty
    | remove (l1, nil) = remove (nil, List.rev l1)
    | remove (l1, a::l2) = (a, (l1, l2))

  fun app (l1, l2) f = List.app f (l2 @ (List.rev l1))

  fun toList (l1, l2) = l2 @ (List.rev l1)

end
