signature C_SASL =
sig
  type connection
  type security_flags = Word32.word

  datatype response = 
    OK of string
  | CONTINUE of string

  exception SaslError of string

  val sasl_done : unit -> unit

  val sasl_dispose : connection -> unit

  val sasl_usererr : Word32.word -> Word32.word

  val sasl_errstring : Word32.word -> string

  val sasl_get_username : connection -> string

  val sasl_build_secflags : unit -> security_flags

  val sasl_set_security_properties : 
    connection -> (int * int * int * security_flags) -> unit

  val sasl_idle : connection -> unit

  val sasl_server_init : string -> unit

  val sasl_server_new : string -> security_flags  -> connection

  val sasl_listmech : (string * string * string) -> connection -> string

  val sasl_server_start : connection -> string -> string option -> response

  val sasl_server_step : connection -> string -> response

  val sasl_checkpass : (string * string) -> bool

end
